# Copyright (c) 2020, JINGROW
# License: MIT. See LICENSE

import jingrow
from jingrow.geo.utils import get_coords
from jingrow.tests.utils import JingrowTestCase


class TestGeoUtils(JingrowTestCase):
	def setUp(self):
		self.todo = jingrow.get_pg(
			dict(pagetype="ToDo", description="Test description", assigned_by="Administrator")
		).insert()

		self.test_location_dict = {
			"type": "FeatureCollection",
			"features": [
				{
					"type": "Feature",
					"properties": {},
					"geometry": {"type": "Point", "coordinates": [49.20433, 55.753395]},
				}
			],
		}
		self.test_location = jingrow.get_pg(
			{"name": "Test Location", "pagetype": "Location", "location": str(self.test_location_dict)}
		)

		self.test_filter_exists = [["Location", "name", "like", "%Test Location%"]]
		self.test_filter_not_exists = [["Location", "name", "like", "%Test Location Not exists%"]]
		self.test_filter_todo = [["ToDo", "description", "like", "%Test description%"]]

	def test_get_coords_location_with_filter_exists(self):
		coords = get_coords("Location", self.test_filter_exists, "location_field")
		self.assertEqual(
			self.test_location_dict["features"][0]["geometry"], coords["features"][0]["geometry"]
		)

	def test_get_coords_location_with_filter_not_exists(self):
		coords = get_coords("Location", self.test_filter_not_exists, "location_field")
		self.assertEqual(coords, {"type": "FeatureCollection", "features": []})

	def test_get_coords_from_not_existable_location(self):
		self.assertRaises(jingrow.ValidationError, get_coords, "ToDo", self.test_filter_todo, "location_field")

	def test_get_coords_from_not_existable_coords(self):
		self.assertRaises(jingrow.ValidationError, get_coords, "ToDo", self.test_filter_todo, "coordinates")

	def tearDown(self):
		self.todo.delete()
